from abc import ABC, abstractmethod
from typing import Optional

from cpl_query.extension import List

from bot_data.model.level import Level


class LevelRepositoryABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    def get_levels(self) -> List[Level]: pass
    
    @abstractmethod
    def get_level_by_id(self, id: int) -> Level: pass

    @abstractmethod
    def find_level_by_id(self, id: int) -> Optional[Level]: pass
    
    @abstractmethod
    def get_levels_by_server_id(self, server_id: int) -> List[Level]: pass
    
    @abstractmethod
    def find_levels_by_server_id(self, server_id: int) -> Optional[List[Level]]: pass
    
    @abstractmethod
    def add_level(self, level: Level): pass
    
    @abstractmethod
    def update_level(self, level: Level): pass
    
    @abstractmethod
    def delete_level(self, level: Level): pass
